SystemOrganization addCategory: #DirWalker!

Object subclass: #DirWalker
	instanceVariableNames: 'path filenames children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DirWalker'!

!DirWalker commentStamp: 'PhilippeQuesnel 3/5/2014 20:10' prior: 0!
a DirWalkerNode represents a directory entry in a tree structure It reads a directory tree in memory.
It offers a walk method to traverse the tree

!

!DirWalker class methodsFor: 'instance creation' stamp: 'PhilippeQuesnel 3/5/2014 20:41'!
newFromStringPath: stringPath
	""

	| dirFileRef |
	dirFileRef := stringPath asFileReference.
	dirFileRef isDirectory ifFalse: [ self error: 'Not a directory: ', stringPath ].
	
	^ self new readAt: dirFileRef.
	! !

!DirWalker methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/5/2014 21:09'!
basename
	"returns the basename for this directory"

	^ path basename! !

!DirWalker methodsFor: 'private tree building' stamp: 'PhilippeQuesnel 3/5/2014 23:36'!
readAt: dirFileRef
	"reads directory, recursing into child dirs"

	path := dirFileRef path.
	filenames := dirFileRef fileNames.
	children := dirFileRef directories collect: [ :kidDirRef | self class new readAt: kidDirRef ]! !
